diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ctrl-headers.h ns-3.44/src/wifi/model/ctrl-headers.h
--- ns-3.43/src/wifi/model/ctrl-headers.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/ctrl-headers.h	2025-03-09 16:55:49.783372600 -0700
@@ -758,20 +761,20 @@
      * is neither 0 nor 2045. This method must be called after setting the AID12
      * subfield to a value other than 0 and 2045.
      *
-     * \param startingSs the starting spatial stream (a value from 1 to 8)
-     * \param nSs the number of spatial streams (a value from 1 to 8)
+     * @param startingSs the starting spatial stream (a value from 1 to 8)
+     * @param nSs the number of spatial streams (a value from 1 to 8)
      */
     void SetSsAllocation(uint8_t startingSs, uint8_t nSs);
     /**
      * Get the starting spatial stream.
      *
-     * \return the starting spatial stream (a value between 1 and 8)
+     * @return the starting spatial stream (a value between 1 and 8)
      */
     uint8_t GetStartingSs() const;
     /**
      * Get the number of spatial streams.
      *
-     * \return the number of spatial streams (a value between 1 and 8)
+     * @return the number of spatial streams (a value between 1 and 8)
      */
     uint8_t GetNss() const;
     /**
@@ -779,15 +782,15 @@
      * is 0 or 2045. This method must be called after setting the AID12 subfield to
      * 0 or 2045.
      *
-     * \param nRaRu the number (from 1 to 32) of contiguous RUs allocated for Random Access.
-     * \param moreRaRu whether RA-RUs are allocated in subsequent Trigger frames
+     * @param nRaRu the number (from 1 to 32) of contiguous RUs allocated for Random Access.
+     * @param moreRaRu whether RA-RUs are allocated in subsequent Trigger frames
      */
     void SetRaRuInformation(uint8_t nRaRu, bool moreRaRu);
     /**
      * Get the number of contiguous RUs for Random Access. This method can only be
      * called if the AID12 subfield has been set to 0 or 2045
      *
-     * \return the number of contiguous RA-RUs (a value between 1 and 32)
+     * @return the number of contiguous RA-RUs (a value between 1 and 32)
      */
     uint8_t GetNRaRus() const;
     /**
@@ -795,7 +798,7 @@
      * that are sent before the end of the current TXOP. This method can only be
      * called if the AID12 subfield has been set to 0 or 2045
      *
-     * \return true if more RA-RUs are allocated in subsequent Trigger frames
+     * @return true if more RA-RUs are allocated in subsequent Trigger frames
      */
     bool GetMoreRaRu() const;
     /**
@@ -807,14 +810,14 @@
      * Set the UL Target RSSI subfield to indicate the expected receive signal
      * power in dBm
      *
-     * \param dBm the expected receive signal power (a value between -110 and -20)
+     * @param dBm the expected receive signal power (a value between -110 and -20)
      */
     void SetUlTargetRssi(int8_t dBm);
     /**
      * Return true if the UL Target RSSI subfield indicates to the station to transmit
      * an HE TB PPDU response at its maximum transmit power for the assigned MCS
      *
-     * \return true if the UL Target RSSI subfield indicates to the station to transmit
+     * @return true if the UL Target RSSI subfield indicates to the station to transmit
      * an HE TB PPDU response at its maximum transmit power for the assigned MCS
      */
     bool IsUlTargetRssiMaxTxPower() const;
@@ -822,36 +825,36 @@
      * Get the expected receive signal power for the solicited HE TB PPDU. This
      * method can only be called if IsUlTargetRssiMaxTxPower returns false.
      *
-     * \return the expected receive signal power in dBm
+     * @return the expected receive signal power in dBm
      */
     int8_t GetUlTargetRssi() const;
     /**
      * Set the Trigger Dependent User Info subfield for Basic Trigger frames.
      *
-     * \param spacingFactor the MPDU MU spacing factor
-     * \param tidLimit the value for the TID Aggregation Limit subfield
-     * \param prefAc the lowest AC recommended for aggregation of MPDUs
+     * @param spacingFactor the MPDU MU spacing factor
+     * @param tidLimit the value for the TID Aggregation Limit subfield
+     * @param prefAc the lowest AC recommended for aggregation of MPDUs
      */
     void SetBasicTriggerDepUserInfo(uint8_t spacingFactor, uint8_t tidLimit, AcIndex prefAc);
     /**
      * Get the MPDU MU spacing factor. This method can only be called if this
      * User Info field is included in a Basic Trigger frame.
      *
-     * \return the MPDU MU spacing factor
+     * @return the MPDU MU spacing factor
      */
     uint8_t GetMpduMuSpacingFactor() const;
     /**
      * Get the TID Aggregation Limit. This method can only be called if this
      * User Info field is included in a Basic Trigger frame.
      *
-     * \return the TID Aggregation Limit
+     * @return the TID Aggregation Limit
      */
     uint8_t GetTidAggregationLimit() const;
     /**
      * Get the Preferred AC subfield. This method can only be called if this
      * User Info field is included in a Basic Trigger frame.
      *
-     * \return the Preferred AC subfield
+     * @return the Preferred AC subfield
      */
     AcIndex GetPreferredAc() const;
     /**
@@ -860,7 +863,7 @@
      * subfield. The BAR Control subfield must indicate either a Compressed
      * BlockAckReq variant or a Multi-TID BlockAckReq variant.
      *
-     * \param bar the BlockAckRequest header object including the BAR Control
+     * @param bar the BlockAckRequest header object including the BAR Control
      *            subfield and the BAR Information subfield
      */
     void SetMuBarTriggerDepUserInfo(const CtrlBAckRequestHeader& bar);
@@ -870,7 +873,7 @@
      * subfield. The BAR Control subfield must indicate either a Compressed
      * BlockAckReq variant or a Multi-TID BlockAckReq variant.
      *
-     * \return the BlockAckRequest header object including the BAR Control
+     * @return the BlockAckRequest header object including the BAR Control
      *         subfield and the BAR Information subfield
      */
     const CtrlBAckRequestHeader& GetMuBarTriggerDepUserInfo() const;
@@ -908,8 +911,8 @@
 };
 
 /**
- * \ingroup wifi
- * \brief Headers for Trigger frames.
+ * @ingroup wifi
+ * @brief Headers for Trigger frames.
  *
  * 802.11ax amendment defines eight types of Trigger frames (see Section 9.3.1.23 of D3.0):
  *   - Basic
@@ -932,7 +935,7 @@
   public:
     CtrlTriggerHeader();
     /**
-     * \brief Constructor
+     * @brief Constructor
      *
      * Construct a Trigger Frame of the given type from the values stored in the
      * given TX vector. In particular:
@@ -945,24 +948,24 @@
      *
      * This constructor cannot be used to construct MU-RTS Trigger Frames.
      *
-     * \param type the Trigger frame type
-     * \param txVector the TX vector used to build this Trigger Frame
+     * @param type the Trigger frame type
+     * @param txVector the TX vector used to build this Trigger Frame
      */
     CtrlTriggerHeader(TriggerFrameType type, const WifiTxVector& txVector);
     ~CtrlTriggerHeader() override;
     /**
      * Copy assignment operator.
      *
-     * \param trigger the Trigger frame to copy
-     * \return a reference to the copied object
+     * @param trigger the Trigger frame to copy
+     * @return a reference to the copied object
      *
      * Ensure that the type of this Trigger Frame is set to the type of the given
      * Trigger Frame before copying the User Info fields.
      */
     CtrlTriggerHeader& operator=(const CtrlTriggerHeader& trigger);
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -977,106 +980,106 @@
      * For the moment, all User Info fields are of the same variant type, hence we
      * forbid changing the Common Info field variant type after adding User Info fields.
      *
-     * \param variant the Common Info field variant
+     * @param variant the Common Info field variant
      */
     void SetVariant(TriggerFrameVariant variant);
     /**
      * Get the Common Info field variant.
      *
-     * \return the Common Info field variant
+     * @return the Common Info field variant
      */
     TriggerFrameVariant GetVariant() const;
     /**
      * Set the Trigger frame type.
      *
-     * \param type the Trigger frame type
+     * @param type the Trigger frame type
      */
     void SetType(TriggerFrameType type);
     /**
      * Get the Trigger Frame type.
      *
-     * \return the Trigger Frame type
+     * @return the Trigger Frame type
      */
     TriggerFrameType GetType() const;
     /**
      * Return a string corresponding to the Trigger Frame type.
      *
-     * \returns a string corresponding to the Trigger Frame type.
+     * @returns a string corresponding to the Trigger Frame type.
      */
     const char* GetTypeString() const;
     /**
      * Return a string corresponding to the given Trigger Frame type.
      *
-     * \param type the Trigger Frame type
-     * \returns a string corresponding to the Trigger Frame type.
+     * @param type the Trigger Frame type
+     * @returns a string corresponding to the Trigger Frame type.
      */
     static const char* GetTypeString(TriggerFrameType type);
     /**
      * Check if this is a Basic Trigger frame.
      *
-     * \return true if this is a Basic Trigger frame,
+     * @return true if this is a Basic Trigger frame,
      *         false otherwise
      */
     bool IsBasic() const;
     /**
      * Check if this is a Beamforming Report Poll Trigger frame.
      *
-     * \return true if this is a Beamforming Report Poll Trigger frame,
+     * @return true if this is a Beamforming Report Poll Trigger frame,
      *         false otherwise
      */
     bool IsBfrp() const;
     /**
      * Check if this is a MU-BAR Trigger frame.
      *
-     * \return true if this is a MU-BAR Trigger frame,
+     * @return true if this is a MU-BAR Trigger frame,
      *         false otherwise
      */
     bool IsMuBar() const;
     /**
      * Check if this is a MU-RTS Trigger frame.
      *
-     * \return true if this is a MU-RTS Trigger frame,
+     * @return true if this is a MU-RTS Trigger frame,
      *         false otherwise
      */
     bool IsMuRts() const;
     /**
      * Check if this is a Buffer Status Report Poll Trigger frame.
      *
-     * \return true if this is a Buffer Status Report Poll Trigger frame,
+     * @return true if this is a Buffer Status Report Poll Trigger frame,
      *         false otherwise
      */
     bool IsBsrp() const;
     /**
      * Check if this is a Groupcast with Retries (GCR) MU-BAR Trigger frame.
      *
-     * \return true if this is a Groupcast with Retries (GCR) MU-BAR Trigger frame,
+     * @return true if this is a Groupcast with Retries (GCR) MU-BAR Trigger frame,
      *         false otherwise
      */
     bool IsGcrMuBar() const;
     /**
      * Check if this is a Bandwidth Query Report Poll Trigger frame.
      *
-     * \return true if this is a Bandwidth Query Report Poll Trigger frame,
+     * @return true if this is a Bandwidth Query Report Poll Trigger frame,
      *         false otherwise
      */
     bool IsBqrp() const;
     /**
      * Check if this is a NDP Feedback Report Poll Trigger frame.
      *
-     * \return true if this is a NDP Feedback Report Poll Trigger frame,
+     * @return true if this is a NDP Feedback Report Poll Trigger frame,
      *         false otherwise
      */
     bool IsNfrp() const;
     /**
      * Set the UL Length subfield of the Common Info field.
      *
-     * \param len the value for the UL Length subfield
+     * @param len the value for the UL Length subfield
      */
     void SetUlLength(uint16_t len);
     /**
      * Get the UL Length subfield of the Common Info field.
      *
-     * \return the UL Length subfield
+     * @return the UL Length subfield
      */
     uint16_t GetUlLength() const;
     /**
@@ -1084,44 +1087,44 @@
      * the HE TB PPDU solicited by this Trigger Frame. Note that the TX power
      * level is not set by this method.
      *
-     * \param staId the STA-ID of a station addressed by this Trigger Frame
-     * \return the TX vector of the solicited HE TB PPDU
+     * @param staId the STA-ID of a station addressed by this Trigger Frame
+     * @return the TX vector of the solicited HE TB PPDU
      */
     WifiTxVector GetHeTbTxVector(uint16_t staId) const;
     /**
      * Set the More TF subfield of the Common Info field.
      *
-     * \param more the value for the More TF subfield
+     * @param more the value for the More TF subfield
      */
     void SetMoreTF(bool more);
     /**
      * Get the More TF subfield of the Common Info field.
      *
-     * \return the More TF subfield
+     * @return the More TF subfield
      */
     bool GetMoreTF() const;
     /**
      * Set the CS Required subfield of the Common Info field.
      *
-     * \param cs the value for the CS Required subfield
+     * @param cs the value for the CS Required subfield
      */
     void SetCsRequired(bool cs);
     /**
      * Get the CS Required subfield of the Common Info field.
      *
-     * \return the CS Required subfield
+     * @return the CS Required subfield
      */
     bool GetCsRequired() const;
     /**
      * Set the bandwidth of the solicited HE TB PPDU.
      *
-     * \param bw bandwidth (allowed values: 20, 40, 80, 160)
+     * @param bw bandwidth (allowed values: 20, 40, 80, 160)
      */
     void SetUlBandwidth(MHz_u bw);
     /**
      * Get the bandwidth of the solicited HE TB PPDU.
      *
-     * \return the bandwidth (20, 40, 80 or 160)
+     * @return the bandwidth (20, 40, 80 or 160)
      */
     MHz_u GetUlBandwidth() const;
     /**
@@ -1131,63 +1134,63 @@
      *   - 2x LTF + 1.6us GI
      *   - 4x LTF + 3.2us GI
      *
-     * \param guardInterval the guard interval duration
-     * \param ltfType the HE-LTF type (1, 2 or 4)
+     * @param guardInterval the guard interval duration
+     * @param ltfType the HE-LTF type (1, 2 or 4)
      */
     void SetGiAndLtfType(Time guardInterval, uint8_t ltfType);
     /**
      * Get the guard interval duration of the solicited HE TB PPDU.
      *
-     * \return the guard interval duration  of the solicited HE TB PPDU
+     * @return the guard interval duration  of the solicited HE TB PPDU
      */
     Time GetGuardInterval() const;
     /**
      * Get the LTF type of the solicited HE TB PPDU.
      *
-     * \return the LTF type of the solicited HE TB PPDU
+     * @return the LTF type of the solicited HE TB PPDU
      */
     uint8_t GetLtfType() const;
     /**
      * Set the AP TX Power subfield of the Common Info field.
      *
-     * \param power the value (from -20 to 40) for the AP TX Power (dBm)
+     * @param power the value (from -20 to 40) for the AP TX Power (dBm)
      */
     void SetApTxPower(int8_t power);
     /**
      * Get the power value (dBm) indicated by the AP TX Power subfield of the
      * Common Info field.
      *
-     * \return the AP TX Power (dBm) per 20 MHz
+     * @return the AP TX Power (dBm) per 20 MHz
      */
     int8_t GetApTxPower() const;
     /**
      * Set the UL Spatial Reuse subfield of the Common Info field.
      *
-     * \param sr the value for the UL Spatial Reuse subfield
+     * @param sr the value for the UL Spatial Reuse subfield
      */
     void SetUlSpatialReuse(uint16_t sr);
     /**
      * Get the UL Spatial Reuse subfield of the Common Info field.
      *
-     * \return the UL Spatial Reuse subfield
+     * @return the UL Spatial Reuse subfield
      */
     uint16_t GetUlSpatialReuse() const;
     /**
      * Set the size in bytes of the Padding field. The Padding field, if present,
      * shall be at least two octets in length.
      *
-     * \param size the size in bytes of the Padding field
+     * @param size the size in bytes of the Padding field
      */
     void SetPaddingSize(std::size_t size);
     /**
-     * \return the size in bytes of the Padding field
+     * @return the size in bytes of the Padding field
      */
     std::size_t GetPaddingSize() const;
     /**
      * Get a copy of the Common Info field of this Trigger frame.
      * Note that the User Info fields are excluded.
      *
-     * \return a Trigger frame including a copy of the Common Info field of this frame.
+     * @return a Trigger frame including a copy of the Common Info field of this frame.
      */
     CtrlTriggerHeader GetCommonInfoField() const;
 
@@ -1196,7 +1199,7 @@
      * a non-const reference to it. Make sure to call this method after
      * setting the type of the Trigger frame.
      *
-     * \return a non-const reference to the newly added User Info field
+     * @return a non-const reference to the newly added User Info field
      */
     CtrlTriggerUserInfoField& AddUserInfoField();
     /**
@@ -1204,8 +1207,8 @@
      * a non-const reference to it. Make sure that the type of the given
      * User Info field matches the type of this Trigger Frame.
      *
-     * \param userInfo the User Info field to append to this Trigger Frame
-     * \return a non-const reference to the newly added User Info field
+     * @param userInfo the User Info field to append to this Trigger Frame
+     * @return a non-const reference to the newly added User Info field
      */
     CtrlTriggerUserInfoField& AddUserInfoField(const CtrlTriggerUserInfoField& userInfo);
 
@@ -1216,33 +1219,41 @@
     typedef std::list<CtrlTriggerUserInfoField>::iterator Iterator;
 
     /**
-     * \brief Get a const iterator pointing to the first User Info field in the list.
+     * Remove a User Info field from the Trigger Frame.
+     *
+     * @param userInfoIt an iterator pointing to the User Info field to remove
+     * @return an iterator following the removed User Info field
+     */
+    Iterator RemoveUserInfoField(ConstIterator userInfoIt);
+
+    /**
+     * @brief Get a const iterator pointing to the first User Info field in the list.
      *
-     * \return a const iterator pointing to the first User Info field in the list
+     * @return a const iterator pointing to the first User Info field in the list
      */
     ConstIterator begin() const;
     /**
-     * \brief Get a const iterator indicating past-the-last User Info field in the list.
+     * @brief Get a const iterator indicating past-the-last User Info field in the list.
      *
-     * \return a const iterator indicating past-the-last User Info field in the list
+     * @return a const iterator indicating past-the-last User Info field in the list
      */
     ConstIterator end() const;
     /**
-     * \brief Get an iterator pointing to the first User Info field in the list.
+     * @brief Get an iterator pointing to the first User Info field in the list.
      *
-     * \return an iterator pointing to the first User Info field in the list
+     * @return an iterator pointing to the first User Info field in the list
      */
     Iterator begin();
     /**
-     * \brief Get an iterator indicating past-the-last User Info field in the list.
+     * @brief Get an iterator indicating past-the-last User Info field in the list.
      *
-     * \return an iterator indicating past-the-last User Info field in the list
+     * @return an iterator indicating past-the-last User Info field in the list
      */
     Iterator end();
     /**
-     * \brief Get the number of User Info fields in this Trigger Frame.
+     * @brief Get the number of User Info fields in this Trigger Frame.
      *
-     * \return the number of User Info fields in this Trigger Frame
+     * @return the number of User Info fields in this Trigger Frame
      */
     std::size_t GetNUserInfoFields() const;
     /**
@@ -1250,9 +1261,9 @@
      * the one pointed to by the given iterator) whose AID12 subfield is set to
      * the given value.
      *
-     * \param start a const iterator pointing to the User Info field to start the search from
-     * \param aid12 the value of the AID12 subfield to match
-     * \return a const iterator pointing to the User Info field matching the specified
+     * @param start a const iterator pointing to the User Info field to start the search from
+     * @param aid12 the value of the AID12 subfield to match
+     * @return a const iterator pointing to the User Info field matching the specified
      * criterion, if any, or an iterator indicating past-the-last User Info field.
      */
     ConstIterator FindUserInfoWithAid(ConstIterator start, uint16_t aid12) const;
@@ -1260,8 +1271,8 @@
      * Get a const iterator pointing to the first User Info field found whose AID12
      * subfield is set to the given value.
      *
-     * \param aid12 the value of the AID12 subfield to match
-     * \return a const iterator pointing to the User Info field matching the specified
+     * @param aid12 the value of the AID12 subfield to match
+     * @return a const iterator pointing to the User Info field matching the specified
      * criterion, if any, or an iterator indicating past-the-last User Info field.
      */
     ConstIterator FindUserInfoWithAid(uint16_t aid12) const;
@@ -1270,8 +1281,8 @@
      * the one pointed to by the given iterator) which allocates a Random Access
      * RU for associated stations.
      *
-     * \param start a const iterator pointing to the User Info field to start the search from
-     * \return a const iterator pointing to the User Info field matching the specified
+     * @param start a const iterator pointing to the User Info field to start the search from
+     * @return a const iterator pointing to the User Info field matching the specified
      * criterion, if any, or an iterator indicating past-the-last User Info field.
      */
     ConstIterator FindUserInfoWithRaRuAssociated(ConstIterator start) const;
@@ -1279,7 +1290,7 @@
      * Get a const iterator pointing to the first User Info field found which allocates
      * a Random Access RU for associated stations.
      *
-     * \return a const iterator pointing to the User Info field matching the specified
+     * @return a const iterator pointing to the User Info field matching the specified
      * criterion, if any, or an iterator indicating past-the-last User Info field.
      */
     ConstIterator FindUserInfoWithRaRuAssociated() const;
@@ -1288,8 +1299,8 @@
      * the one pointed to by the given iterator) which allocates a Random Access
      * RU for unassociated stations.
      *
-     * \param start a const iterator pointing to the User Info field to start the search from
-     * \return a const iterator pointing to the User Info field matching the specified
+     * @param start a const iterator pointing to the User Info field to start the search from
+     * @return a const iterator pointing to the User Info field matching the specified
      * criterion, if any, or an iterator indicating past-the-last User Info field.
      */
     ConstIterator FindUserInfoWithRaRuUnassociated(ConstIterator start) const;
@@ -1297,7 +1308,7 @@
      * Get a const iterator pointing to the first User Info field found which allocates
      * a Random Access RU for unassociated stations.
      *
-     * \return a const iterator pointing to the User Info field matching the specified
+     * @return a const iterator pointing to the User Info field matching the specified
      * criterion, if any, or an iterator indicating past-the-last User Info field.
      */
     ConstIterator FindUserInfoWithRaRuUnassociated() const;
@@ -1309,7 +1320,7 @@
      * This function shall be invoked before transmitting and upon receiving
      * a Trigger frame.
      *
-     * \return true if the Trigger frame is valid, false otherwise.
+     * @return true if the Trigger frame is valid, false otherwise.
      */
     bool IsValid() const;
 
